Ticket #39259

Kermit転送のファイル属性のタイムスタンプについて

Open Date: 2019-05-27 09:37 Last Update: 2019-06-20 11:37

Reporter:
Owner:
Status:
Closed
Component:
MileStone:
(None)
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Fixed
File:
None
Vote
Score: 0
No votes
0.0% (0/0)
0.0% (0/0)

Details

Kermitファイル転送で、ファイル属性情報を通知するように KmtFileAttr=on と設定して、ファイル送信時のタイムスタンプを確認すると、Windowsのファイルプロパティーで確認できる「作成日時」が通知されています。できれば「更新日時」を通知して貰いたいです。 どこかで設定変更とか出来たりしますでしょうか? 現在公開の最新版のバージョンでも確認しましたが、同様でした。


以下、動作変更に関するメモ。

規格上の規定

KERMIT PROTOCOL MANUAL Sixth Edition より。

6.5. Transmitting File Attributes
~略~
# (ASCII 35)
        Creation Date, expressed as "[yy]yymmdd[ hh:mm[:ss]]" (ISO standard date format), e.g.
        831009 23:59. The time is optional; if given, it should be in 24-hour format, and the seconds may
        be omitted, and a single space should separate the time from the date.

上記のとおり、規格上では作成日時(Creation Date)を使うとされている。

環境、および各実装

Unix系OS, C-Kermit

Unix系OSで使われているファイルシステムでは、ファイル作成日時が記録されていない、またはOS独自の拡張として実装されている為、汎用的に作成日時を取得する方法が無い。

その為、C-Kermit では作成日時ではなく修正日時(st_mtime)を使うようになっている。

Windows95/98/Me, C-Kermit/Kermit95

DOSやWindows95系で使われる FAT も修正日時しかない。その為 C-Kermit, Kermit95ではUnix系OSと同じようにst_mtimeを使う。

Windows95/98/Me, Tera Term

前述したように、FAT では st_mtime しか使えない。しかし WindowsNTのNTFSで st_ctime が作成日時とされた影響なのか、Tera Term では st_ctime を使うようになっている。

FAT では st_ctime が使えないが、実際には st_mtime と同じ値が得られていたと思われる(未確認)為、Windows95系(FAT) で使う分には問題が顕在化しなかったと思われる。

WindowsNT系, Tera Term

ファイルシステムがNTFSとなり st_ctime でファイル作成日時が得られるようになった為、他の実装との間で動作の違いが表に出てきた。

対応

規格上は Tera Term の動作が正しいが、本家の C-Kermit と動作が違うのは望ましく無い為、C-Kermit に合わせて st_mtime を使うように変更する。

Ticket History (3/7 Histories)

2019-05-27 09:37 Updated by: jr4qpv
  • New Ticket "Kermit転送のファイル属性のタイムスタンプについて" created
2019-05-27 19:05 Updated by: doda
  • Resolution Update from None to Accepted
  • Component Update from (None) to Tera Term
Comment

プロトコルの仕様としては Creation Date となっているのですが、kermit95のソースを眺めた感じだと更新日時の方を使っているようですね。

検討します。

2019-06-01 14:53 Updated by: None
Comment

お返事ありがとうございます。 C-Kermitも更新日時のようでした。 よろしくご検討お願いします。

2019-06-12 20:43 Updated by: doda
  • Owner Update from (None) to doda
  • Resolution Update from Accepted to Fixed
Comment

r7760 にて動作変更。Tera Term 4.103 より更新日時を通知するようになります。

2019-06-12 21:28 Updated by: None
Comment

Reply To doda

r7760 にて動作変更。Tera Term 4.103 より更新日時を通知するようになります。

ありがとうございました。

2019-06-12 22:46 Updated by: doda
  • Details Updated
2019-06-20 11:37 Updated by: doda
  • Status Update from Open to Closed

Attachment File List

No attachments

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login